SELECT "documents_elementpath"."id",
       "documents_elementpath"."element_id",
       "documents_elementpath"."path",
       "documents_elementpath"."ordering"
FROM "documents_elementpath"
WHERE "documents_elementpath"."element_id" = '{source_id}'::uuid;

SELECT "documents_element"."id",
       "documents_element"."created",
       "documents_element"."updated",
       "documents_element"."corpus_id",
       "documents_element"."type_id",
       "documents_element"."name",
       "documents_element"."zone_id",
       "documents_element"."worker_version_id"
FROM "documents_element"
WHERE "documents_element"."id" = '{parent_id}'::uuid
LIMIT 21;

SAVEPOINT "{savepoints[0]}";

SELECT (1) AS "a"
FROM "documents_elementpath"
WHERE ("documents_elementpath"."element_id" = '{source_id}'::uuid
       AND "documents_elementpath"."path"[array_length("documents_elementpath"."path", 1)] = '{parent_id}'::uuid)
LIMIT 1;

SELECT (1) AS "a"
FROM "documents_elementpath"
WHERE ("documents_elementpath"."element_id" = '{source_id}'::uuid
       AND NOT ("documents_elementpath"."path"[array_length("documents_elementpath"."path", 1)] = '{parent_id}'::uuid))
LIMIT 1;

SELECT DISTINCT "documents_element"."id",
                "documents_element"."created",
                "documents_element"."updated",
                "documents_element"."corpus_id",
                "documents_element"."type_id",
                "documents_element"."name",
                "documents_element"."zone_id",
                "documents_element"."worker_version_id",
                "documents_elementpath"."ordering"
FROM "documents_element"
INNER JOIN "documents_elementpath" ON ("documents_element"."id" = "documents_elementpath"."element_id")
WHERE "documents_elementpath"."path" @ > ARRAY['{source_id}'::uuid]::uuid[]
ORDER BY "documents_elementpath"."ordering" ASC;

SELECT DISTINCT "documents_element"."id",
                "documents_element"."created",
                "documents_element"."updated",
                "documents_element"."corpus_id",
                "documents_element"."type_id",
                "documents_element"."name",
                "documents_element"."zone_id",
                "documents_element"."worker_version_id",
                "documents_elementpath"."ordering"
FROM "documents_element"
INNER JOIN "documents_elementpath" ON ("documents_element"."id" = "documents_elementpath"."element_id")
WHERE "documents_elementpath"."path" @ > ARRAY['{source_id}'::uuid]::uuid[]
ORDER BY "documents_elementpath"."ordering" ASC;

DELETE
FROM "documents_elementpath"
WHERE ("documents_elementpath"."element_id" IN ('{source_id}'::uuid)
       AND "documents_elementpath"."path" @ > ARRAY['{parent_id}'::uuid]::uuid[]);

RELEASE SAVEPOINT "{savepoints[0]}";

SAVEPOINT "{savepoints[1]}";

SELECT "documents_elementpath"."element_id",
       "documents_elementpath"."path"
FROM "documents_elementpath"
WHERE "documents_elementpath"."element_id" IN ('{source_id}'::uuid,
                                               '{destination_id}'::uuid);

SELECT "documents_elementtype"."id",
       "documents_elementtype"."corpus_id",
       "documents_elementtype"."slug",
       "documents_elementtype"."display_name",
       "documents_elementtype"."folder",
       "documents_elementtype"."indexable"
FROM "documents_elementtype"
WHERE "documents_elementtype"."id" = '{page_type_id}'::uuid
LIMIT 21;

SELECT (MAX("documents_elementpath"."ordering") + 1) AS "max"
FROM "documents_elementpath"
INNER JOIN "documents_element" ON ("documents_elementpath"."element_id" = "documents_element"."id")
WHERE ("documents_element"."type_id" = '{page_type_id}'::uuid
       AND "documents_elementpath"."path"[array_length("documents_elementpath"."path", 1)] = '{destination_id}'::uuid
       AND "documents_elementpath"."path" && ARRAY['{destination_id}'::uuid]::uuid[]);

SELECT "documents_elementpath"."id",
       "documents_elementpath"."element_id",
       "documents_elementpath"."path",
       "documents_elementpath"."ordering"
FROM "documents_elementpath"
WHERE "documents_elementpath"."path" @ > ARRAY['{source_id}'::uuid]::uuid[];

INSERT INTO "documents_elementpath" ("id",
                                     "element_id",
                                     "path",
                                     "ordering")
VALUES ('{path_id}'::uuid, '{source_id}'::uuid, ARRAY['{destination_id}'::uuid]::uuid[], 3);

RELEASE SAVEPOINT "{savepoints[1]}"